"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResultUtils = void 0;
const neverthrow_1 = require("neverthrow");
class ResultUtils {
    static combine(asyncResultList) {
        return neverthrow_1.ResultAsync.fromPromise(Promise.all(asyncResultList), (e) => {
            return e;
        }).andThen(ResultUtils.combineResultList);
    }
    static combineResultList(resultList) {
        return resultList.reduce((acc, result) => {
            return acc.isOk()
                ? result.isErr()
                    ? neverthrow_1.err(result.error)
                    : acc.map((values) => {
                        values.push(result.value);
                        return values;
                    })
                : acc;
        }, neverthrow_1.ok([]));
    }
}
exports.ResultUtils = ResultUtils;
//# sourceMappingURL=ResultUtils.js.map